#include "../BasicCompiler_Common/common.h"

#ifdef _AMD64_
#include "../BasicCompiler64/opcode.h"
#else
#include "../BasicCompiler32/opcode.h"
#endif

extern HANDLE hHeap;

int GetAlignment(CClass *pobj_c){
	int i;
	int alignment,member_size;

	if(pobj_c->vtbl_num) alignment=PTR_SIZE;
	else alignment=0;

	for(i=0;i<pobj_c->iMemberNum;i++){
		if(pobj_c->ppobj_Member[i]->TypeInfo.type==DEF_OBJECT){
			//oNX̃ACg擾
			member_size=GetAlignment(pobj_c->ppobj_Member[i]->TypeInfo.u.pobj_Class);
		}
		else{
			//oTCY擾
			member_size=GetTypeSize(pobj_c->ppobj_Member[i]->TypeInfo.type,pobj_c->ppobj_Member[i]->TypeInfo.u.lpIndex);
		}

		//ACgZbg
		if(alignment<member_size) alignment=member_size;
	}

	if(alignment==0) return 0;

	if(pobj_c->iAlign) alignment=pobj_c->iAlign;

	return alignment;
}
int GetSizeOfClassMember(CClass *pobj_c,char *pMemberName,int *pMemberNum){
	int i,i2,offset;

	//z֐݂ꍇ͊֐Xgւ̃|C^̃TCYǉ
	if(pobj_c->vtbl_num) offset=PTR_SIZE;
	else offset=0;

	int alignment;
	if(pobj_c->iAlign) alignment=pobj_c->iAlign;
	else alignment=1;

	int iMaxAlign=0;
	for(i=0;i<pobj_c->iMemberNum;i++){
		//oϐ̌^TCY擾
		i2=GetTypeSize(pobj_c->ppobj_Member[i]->TypeInfo.type,pobj_c->ppobj_Member[i]->TypeInfo.u.lpIndex);
		if(i2==-1) return -1;

		//ACgZo
		int member_size;
		if(pobj_c->ppobj_Member[i]->TypeInfo.type==DEF_OBJECT){
			//oNX̃ACg擾
			member_size=GetAlignment(pobj_c->ppobj_Member[i]->TypeInfo.u.pobj_Class);
		}
		else{
			//oTCY擾
			member_size=i2;
		}
		if(iMaxAlign<member_size) iMaxAlign=member_size;

		//ACgl
		if(pobj_c->iAlign&&pobj_c->iAlign<member_size){
			if(offset%alignment) offset+=alignment-(offset%alignment);
		}
		else{
			if(alignment<member_size) alignment=member_size;

			if(member_size==0){
				//oȂNX
				//ȂiItZbǧvZȂj
			}
			else{
				if(offset%member_size) offset+=member_size-(offset%member_size);
			}
		}

		if(pMemberName){
			//ow肪ꍇ́AItZbgԂ
			if(lstrcmp(pobj_c->ppobj_Member[i]->name,pMemberName)==0){
				if(pMemberNum) *pMemberNum=i;
				return offset;
			}
		}

		//zloTCY擾
		member_size=i2 * JumpSubScripts(pobj_c->ppobj_Member[i]->SubScripts);

		//oTCYZ
		offset+= member_size;
	}

	if(iMaxAlign<alignment) alignment=iMaxAlign;

	//ACgl
	if(alignment){
		if(offset%alignment) offset+=alignment-(offset%alignment);
	}

	if(pMemberNum) *pMemberNum=i;
	return offset;
}
int GetSizeOfClass(CClass *pobj_c){
	return GetSizeOfClassMember(pobj_c,0,0);
}


void CallConstractor(char *ObjectName,int *SubScripts,TYPEINFO &TypeInfo,char *Parameter){
	if(TypeInfo.type!=DEF_OBJECT) return;

	/////////////////////////////////////
	// NXIuWFNg̏ꍇ
	// RXgN^̌Ăяo
	/////////////////////////////////////
	CClass *pobj_c;
	pobj_c=(CClass *)TypeInfo.u.lpIndex;

	SUBINFO *psi;
	psi=GetMethodHash(ObjectName,pobj_c->name,Parameter);
	if(!psi){
		if(Parameter[0]) SetError(113,pobj_c->name,cp);
		return;
	}


	char temporary[VN_SIZE];

	if(SubScripts[0]!=-1){
		int ss[MAX_ARRAYDIM];
		memset(ss,0,MAX_ARRAYDIM*sizeof(int));
		while(1){
			int i3;
			for(i3=0;;i3++){
				if(SubScripts[i3]==-1) break;

				if(ss[i3]>SubScripts[i3]){
					ss[i3]=0;
					ss[i3+1]++;
				}
				else break;
			}
			if(SubScripts[i3]==-1) break;
			sprintf(temporary,"%s[%d",ObjectName,ss[0]);
			for(i3=1;;i3++){
				if(SubScripts[i3]==-1) break;

				sprintf(temporary+lstrlen(temporary),",%d",ss[i3]);
			}
			lstrcat(temporary,"]");

			LONG_PTR lp;
			sprintf(temporary+lstrlen(temporary),".%s",pobj_c->name);
			CallProc(PROC_DEFAULT,
				psi,
				temporary,
				Parameter,
				&lp);

			ss[0]++;


			//lCeBuR[hobt@̍Ċm
			extern int obp_AllocSize;
			if(obp_AllocSize<obp+8192){
				obp_AllocSize+=8192;
				OpBuffer=(char *)HeapReAlloc(hHeap,0,OpBuffer,obp_AllocSize); //matea
			}
		}
	}
	else{
		LONG_PTR lp;
		sprintf(temporary,"%s.%s",ObjectName,pobj_c->name);
		CallProc(PROC_DEFAULT,
			psi,
			temporary,
			Parameter,
			&lp);
	}
}
